-- Copyright (c) 2013 Cloudera, Inc. All rights reserved.
--
-- Version 12 of the CMON schema.
--
-- Change MySQL indexes on CMON_ACTIVITY.
-- Change the partition information table to have an explicit start time and
-- a type.
-- Create explicit time-range partitions if needed (done in java).
ALTER TABLE PARTITION_INFO ADD (BEGIN_TS number(19,0));
ALTER TABLE PARTITION_INFO ADD (TYPE number(10,0));
-- '0' is the ordinal of the PERIODIC PartitionType enum value.
UPDATE PARTITION_INFO SET TYPE = 0 WHERE TYPE IS NULL;
ALTER TABLE PARTITION_INFO ADD CONSTRAINT NOT_NULL_PARTITION_INFO_TYPE CHECK (TYPE IS NOT NULL);

-- Create an index on the start and end time of activities.
CREATE INDEX IDX_ACTIVITY_START_TIME ON CMON_ACTIVITY(BEGIN_TS);
CREATE INDEX IDX_ACTIVITY_END_TIME ON CMON_ACTIVITY(END_TS);

-- For some reason this did not use a sequence. Let's fix it as it will
-- make our life when creating partitions easier.
CREATE SEQUENCE CMON_ATTEMPT_SEQUENCE
  START WITH 1
  NOMAXVALUE;

-- We need to rename the sequences as we explicitly use their name in
-- the java code and they should match the new short names we are using
-- for amon partition templates.
RENAME CMON_ATTEMPT_LMV_SEQUENCE TO CMON_ATT_LMV_SEQUENCE;
RENAME CMON_ACTIVITY_LMV_SEQUENCE TO CMON_ACT_LMV_SEQUENCE;

-- Partition old data if necessary.
com.cloudera.cmon.firehose.db.PartitionOldAmonData
